var kappName = "XPCOM libxml";
var kappVersion = "1.0.0.1";
var kappChromeName = "xpcomlibxml";

var ksuccessMessage = "The XPCOM libxml has been successfully installed.\n"
	+ "Restart mozilla to continue.\n\n"
	+ "Note:\n"
	+ "	1. Add line to pspref.js in your home dir:\n"
	+ "	user_pref(\"signed.applets.codebase_principal_support\", true);\n";
var kerrorMessage   = "Install failed! You probably don't have appropriate permissions (write access to the mozilla/chrome directory.)";

var err = initInstall(kappName, kappChromeName, kappVersion); 
logComment("initInstall: " + err);

var errPlatformDetect = 0;
var platformStr = new String(platform);
logComment("Platform: " + platformStr.toString());

if (platformStr.search(/^Win/) > -1) {
	addFile(kappName, kappVersion,
					"xpcomlibxml.dll",
					getFolder("Components"),
					"xpcomlibxml.dll",
					true);
	addFile(kappName, kappVersion,
					"xpcomlibxml.xpt",
					getFolder("Components"),
					"xpcomlibxml.xpt",
					true);
	addFile(kappName, kappVersion,
					"libxml2.dll",
					getFolder("Program"),
					"libxml2.dll",
					true);
	addFile(kappName, kappVersion,
					"libxslt.dll",
					getFolder("Program"),
					"libxslt.dll",
					true);
	addFile(kappName, kappVersion,
					"libexslt.dll",
					getFolder("Program"),
					"libexslt.dll",
					true);
	addFile(kappName, kappVersion,
					"iconv.dll",
					getFolder("Program"),
					"iconv.dll",
					true);
	var regxpcom = getFolder("Program", "./regxpcom.exe");
	File.execute(regxpcom, "")
} else if (platformStr.search(/Linux/) > -1) {
	addFile(kappName, kappVersion,
					"libxpcomlibxml.so",
					getFolder("Components"),
					"libxpcomlibxml.so",
					true);
	addFile(kappName, kappVersion,
					"xpcomlibxml.xpt",
					getFolder("Components"),
					"xpcomlibxml.xpt",
					true);
	var compregdat = getFolder("Components", "./compreg.dat")
	File.remove(compregdat);
	var runmozilla = getFolder("Program", "./run-mozilla.sh");
	File.execute(runmozilla, "./regxpcom")
} else {
	alert('Platform not recognized');
	errPlatformDetect = 1;
	cancelInstall();
}

if (!errPlatformDetect) {

	var err = getLastError();

	if (err == SUCCESS) {
		err = performInstall();
		if (err == SUCCESS) alert(ksuccessMessage);
		else {
			alert(kerrorMessage);
			cancelInstall(err)
		}
	} else cancelInstall(err);
}
